
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% display_vmr_in_matlab.m
% Script to display a BrainVoyager VMR project in Matlab
% Warning: executing this script can last more than half an hour!
% Works with BrainVoyager QX 1.9
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%bvqx = actxserver('BrainVoyagerQX.BrainVoyagerQXInterface');
[FileName,PathName] = uigetfile('*.vmr','Please select a VMR file');
vmrfilename = [PathName FileName];
% vmr = bvqx.OpenDocument(vmrfilename);
% bvqx.PrintToLog('Get voxel intensities in Matlab...');
% for k = 1:vmr.DimZ
%     for j = 1:vmr.DimY
%         for i = 1:vmr.DimX
%             vmrdata(i,j,k) = vmr.GetVoxelIntensity(i,j,k);
%         end
%     end
% end

fid = fopen(vmrfilename, 'rb');
version = fread(fid, [1 1], 'uint16'); 
dimx = fread(fid, [1 1], 'uint16'); 
dimy = fread(fid, [1 1], 'uint16'); 
dimz = fread(fid, [1 1], 'uint16');
data = fread(fid, [1 dimx*dimy*dimz], 'uchar');
%rest = fread(fid);
fclose(fid);
vmrdata = reshape(data, dimx, dimy, dimz);

figure;
h1 = subplot(1,3,1); imagesc(vmrdata(:,:,floor(dimx/2))); title('sagittal view'); axis image xy off
h2 = subplot(1,3,2); imagesc(squeeze(vmrdata(:,floor(dimy/2),:))); title('axial view'); axis image xy off
h3 = subplot(1,3,3); imagesc(squeeze(vmrdata(floor(dimz/2),:,:))); title('coronal view'); axis image xy off
colormap gray

% apply filter (zie ook dsp script)


%[Selection,ok] = listdlg('ListString',S,...)
    
figure;
img = vmrdata(:,:,floor(dimx/2));
subplot(2,2,1);imagesc(img);title('Original Image'); 
H = fspecial('motion',50,45);
MotionBlur = imfilter(img,H);
subplot(2,2,2);imagesc(MotionBlur);title('Motion Blurred Image');
H = fspecial('disk',10);
blurred = imfilter(img,H);
subplot(2,2,3);imagesc(blurred);title('Blurred Image');
H = fspecial('unsharp');
sharpened = imfilter(img,H);
subplot(2,2,4);imagesc(sharpened);title('Sharpened Image');
colormap gray;

%h1 = subplot(1,3,1); imagesc(resvmr(:,:,100)); title('sagittal view'); axis image xy off
%h2 = subplot(1,3,2); imagesc(squeeze(resvmr(:,100,:))); title('axial view'); axis image xy off
%h3 = subplot(1,3,3); imagesc(squeeze(resvmr(100,:,:))); title('coronal view'); axis image xy off
