
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% dsp.m
% Script to ... in Matlab
% 
% Works with BrainVoyager QX 1.9
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


Because of the energy compaction mentioned above, it is possible to reconstruct a signal 
from only a fraction of its DCT coefficients. For example, generate a 25 Hz sinusoidal sequence, 
sampled at 1000 Hz: t = (0:1/999:1);
x = sin(2*pi*25*t);
Compute the DCT of this sequence and reconstruct the signal using only those components with 
value greater than 0.1 (64 of the original 1000 DCT coefficients): 
%y = dct(x)                   % Compute DCT
imgdct = dct(img);
figure;
subplot(1,3,1); imagesc(img);title('Original image'); colormap gray;
subplot(1,3,2); plot(imgdct);title('Discrete cosine transform (DCT) of image'); 
subplot(1,3,3); plot(fft2(imgdct));title('Fourier transform of DCT of image'); 

%%%%%%%%% THIS IS COOL! See DSP, pg 496 %%%%%%%%%%%%%%%%%%%%%%%%
figure;
subplot(2,3,1); imagesc(img);title('Original image'); colormap gray;
subplot(2,3,2); imshow(imgdct);title('Discrete cosine transform (DCT) of image'); 
%subplot(2,3,2); plot(imgdct);title('Discrete cosine transform (DCT) of image'); 
subplot(2,3,3); plot(fft2(imgdct));title('Fourier transform of DCT of image'); 
line = img(:,128);
%line = img(128,:);
linedct = dct(line);
subplot(2,3,4); plot(line);title('Original line'); 
%imagesc(line);title('Original line'); colormap gray;
subplot(2,3,5); plot(linedct);title('Discrete cosine transform (DCT) of line'); 
subplot(2,3,6); plot(fft2(linedct));title('Fourier transform of DCT of line'); 


%y2 = find(abs(imgdct) < 0.9);  % Use 17 coefficients
y2 = find(abs(imgdct) > 0.01);  % Use 17 coefficients
imgdct1d = reshape(imgdct, [],1);
imgdct1d(y2) = zeros(size(imgdct1d));     % Zero out points < 0.9
z = idct(imgdct);                 % Reconstruct signal using inverse DCT
imgidct = reshape(z, 256, 256);
figure;
imshow(imgidct)
imagesc(imgidct)

y2 = find(abs(y) < 0.9);  % Use 17 coefficients
y(y2) = zeros(size(y2));     % Zero out points < 0.9
z = idct(y);                 % Reconstruct signal using inverse DCT