%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% processParamsMatrix.m
% Script to process ICA data: the ParamsMatrix.txt
%
% Use: Load in Matlab, press 'run'
% Hester Breman, Brain Innovation, 2006.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% read ParamsMatrix.txt taak 1
[FileName,PathName] = uigetfile('*.txt','Please select the ParamsMatrix.txt file...');
paramsFile1 = strcat(PathName, FileName);    
[clustering skewness kurtosis spatialEntropy AR1 temporalEntropy power0to0_0008 power0_0008to0_02 power0_02to0_05 power0_05to0_1 power0_1to0_25] = ...
textread(paramsFile1, '%f %f %f %f %f %f %f %f %f %f %f');
task1 = [clustering skewness kurtosis spatialEntropy AR1 temporalEntropy power0to0_0008 power0_0008to0_02 power0_02to0_05 power0_05to0_1 power0_1to0_25];

meansTask1 = mean(task1); % means per type of measure
stdTask1 = std(task1);
figure;
plot(task1',  'LineWidth', 1, 'Color', 'black');
hold on
plot(meansTask1, '*')
xlabel('1:clust 2:skew 3:kurt 4:entropy(xyz) 5:AR(1) 6:entropy(t) 7:pow 0-0.0008  8:pow 0.0008-0.02 9:pow 0.02-0.05 10:pow 0.05-0.1 11:pow 0.1-0.25');

% components classified as BOLD in for example: 6, 8, 9, 10, 16, 21
BOLD(1, :) = task1(6,:);
BOLD(2, :) = task1(8,:);
BOLD(3, :) = task1(9,:);
BOLD(4, :) = task1(10,:);
BOLD(5, :) = task1(16,:);
BOLD(6, :) = task1(21,:);
hold on
BOLDline = plot(BOLD', 'LineWidth', 2, 'Color', 'green');
title('Scores of independent components on 11 fingerprint dimensions (green: presumed BOLD components, *: mean of all components)');
hold off
